%global momorel 13

Summary: A dictionary server for the SKK Japanese input method system
Name: dbskkd-cdb
Version: 1.01
Release: %{momorel}m
License: GPL
Group: System Environment/Daemons
Source0: http://www.ne.jp/asahi/bdx/info/software/%{name}-%{version}.tar.gz
NoSource: 0
Source1: skkserv-xinetd
Patch0: dbskkd-cdb-1.01-freecdb.patch
Patch1: dbskkd-cdb-1.01-sighup.patch
Patch2: dbskkd-cdb-1.01-args.patch
URL: http://www.ne.jp/asahi/bdx/info/software/jp-dbskkd.html
BuildRoot: %{_tmppath}/%{name}-%{version}-root
PreReq: chkconfig, xinetd
PreReq: procps
PreReq: skk-jisyo >= 1.0-13m
BuildPreReq: freecdb, freecdb-devel, skk-jisyo >= 1.0-13m
Requires: freecdb
Obsoletes: rskkserv
Provides: dbskkd-cdb, skkserv

%description
dbskkd-cdb is a dictionary server for the SKK Japanese input method
system.  dbskkd-cdb is based on the code of skkserv (the original SKK
server) 3.9.3, using the cdb constant database package of
D. J. Bernstein (DJB) for faster dictionary access.

Add an entry for dbskkd-cdb to /etc/hosts.allow when using with tcp_wrappers.
ex. dbskkd-cdb: 127.0.0.1

%prep
%setup -q
%patch0 -p1
%patch1 -p0 -b .sighup~
%patch2 -p0 -b .argv~

%build
make SERVERDIR=%{_sbindir} CC='gcc $(CFLAGS)' \
    CFLAGS="%(echo '%{optflags}'|sed -e 's/-fomit-frame-pointer//g')" LDFLAGS='-lutil -lfreecdb'
sh skktocdbm.sh < %{_datadir}/skk/SKK-JISYO.Momonga | \
    cdbmake SKK-JISYO.Momonga.cdb SKK-JISYO.Momonga.tmp

#    CFLAGS="%(echo '%{optflags}'|sed -e 's/-fstack-protector//g' -e 's/-funroll-loops//g' -e 's/-fomit-frame-pointer//g')" LDFLAGS='-lutil -lfreecdb'

%install
mkdir -p %{buildroot}%{_sbindir}
install -c -s -m 0755 dbskkd-cdb %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_bindir}
install -c -m 0755 skktocdbm.sh %{buildroot}%{_bindir}/skktocdbm
mkdir -p %{buildroot}%{_datadir}/skk
install -c -m 0644 SKK-JISYO.Momonga.cdb %{buildroot}%{_datadir}/skk

mkdir -p %{buildroot}%{_sysconfdir}/xinetd.d
install -c -m 0644 %{SOURCE1} %{buildroot}/etc/xinetd.d/skkserv

%triggerin -- skk-jisyo
if test "$2" = "2"; then
    pushd %{_datadir}/skk >/dev/null
    if ps aux | grep dbskkd -q; then
	skktocdbm < SKK-JISYO.Momonga | \
	    cdbmake SKK-JISYO.Momonga.cdb.rpmnew SKK-JISYO.Momonga.tmp
    else
	skktocdbm < SKK-JISYO.Momonga | \
	    cdbmake SKK-JISYO.Momonga.cdb SKK-JISYO.Momonga.tmp
    fi
    popd >/dev/null
fi

%post
for pid in `ps ax | grep dbskkd-cdb | grep -v 'grep\|mph\|rpm' | awk '{print $1}'`; do
    kill -HUP $pid
done

%postun
if test "$1" = "0"; then
    (test -e /var/run/xinetd.pid && kill -USR2 `cat /var/run/xinetd.pid`) || true
fi

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc LICENSE Release-Notes.*
%config(missingok,noreplace) %{_sysconfdir}/xinetd.d/skkserv
%{_bindir}/skktocdbm
%{_sbindir}/dbskkd-cdb
%{_datadir}/skk/*

%changelog
* Wed Aug  4 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (1.01-13m)
- momonganize
- stop service

* Wed Apr  7 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (1.01-12m)
- add PreReq: procps (/bin/ps)

* Wed Aug 13 2003 HOSONO Hidetomo <h12o@h12o.org>
- (1.01-11m)
- add BuildPreReq: freecdb (/usr/bin/cdbmake is needed)

* Mon Jan 13 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (1.01-10m)
- drop -fomit-frame-pointer from CFLAGS to avoid infinite loop

* Fri Nov 22 2002 KOMATSU Shinichiro <koma2@jiro.c.u-tokyo.ac.jp>
- (1.01-9m)
- correct dbskkd-cdb-1.01-sighup.patch to avoid infinite loop
- modify dbskkd-cdb-1.01-args.patch to use JISHO_FILE 
  if no command line argument is supplied.
- do not send SIGHUP to rpm ;P

* Sat May 18 2002 Toru Hoshina <t@kondara.org>
- (1.01-8k)
- minagorosi...

* Sat Nov 24 2001 Toru Hoshina <t@kondara.org>
- (1.01-6k)
- needs PreReq xinetd.
- create new patch for SIGHUP behavior.

* Mon Nov 12 2001 Toru Hoshina <t@kondara.org>
- (1.01-4k)
- needs BuildPreReq skk-jisyo.

* Sun Nov  4 2001 Kenta MURATA <muraken2@nifty.com>
- build against Kondara.

* Fri Nov 05 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- built against RHL-5.2/i386

* Fri Nov 05 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- 1st release
